package com.huimv.environ.eco.controller;


import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.huimv.common.utils.Result;
import com.huimv.common.utils.ResultCode;
import com.huimv.environ.eco.entity.BaseFloor;
import com.huimv.environ.eco.service.IBaseFloorService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author astupidcoder
 * @since 2021-11-11
 */
@RestController
@RequestMapping("/floor")
public class BaseFloorController {

    @Autowired
    private IBaseFloorService baseFloorService;

    @GetMapping("list")
    public Result list(@RequestParam(name = "farmId") Integer farmId){
        return new Result(ResultCode.SUCCESS,baseFloorService.list(new QueryWrapper<BaseFloor>().eq("farm_id",farmId)));
    }

}
